' This VB-Script starts and checks the Automot-Demo using Signals
' The Variable EngSpeed is assigned to the Signal  EngSpeed of the message EngineData
' The Variable CarSpeed is assigned to the Signal  CarSpeed of the message ABSdata
'-----------------------------------------------------------------------------
' Copyright (c) 1999 - 2000 by Vector Informatik GmbH.  All rights reserved.

  Dim EngName, CarName
  Dim CountryStream, StrictStream, FSO
  Dim FullName
  Dim flag

  Const CountryFilePath = "..\..\..\..\exec32\vector.ini"
  Const StrictFilePath = "..\..\..\..\vcustom.ini"

  flag      = 0

  ' get the ToolInfo object
  Set tool = CreateObject("CANutil.ToolInfo")
  Set FSO = CreateObject("Scripting.FileSystemObject")
  Set CountryStream = FSO.OpenTextFile(CountryFilePath,1)
  Set StrictStream = FSO.OpenTextFile(StrictFilePath,1)

  ' show disclaimer (language, strict, beta, education)
  if tool.ShowDisclaimer(ReadCountry(),ReadStrict(), 0, 0) <> 1 Then
    wscript.quit
  end if
  
  Set App = CreateObject( "CANoe.Application")
  Set Measurement = App.Measurement
  WScript.ConnectObject App, "App_"

  On Error Resume Next 

  Do 
    Err.Clear
    OpenConfig "\..\..\Automot.cfg", Measurement   
    WScript.Sleep 500	
  Loop While flag = 0  'Error: User interface is busy	

  App.CAPL.Compile

  If not Measurement.Running Then
    Measurement.Start

    EngName = "EngSpeed"
    CarName = "CarSpeed"

    Set Start = App.Environment.GetVariable( "EnvGWStarter_")
    Set EngSpeed = App.Bus.GetSignal(2, "EngineData", "EngSpeed")
    Set CarSpeed = App.Bus.GetSignal(2, "ABSdata", "CarSpeed")


    While not Start.value = 1
      Wscript.Sleep 10
    Wend

    WScript.Sleep 5000

    ShowSignal EngName, EngSpeed
    ShowSignal CarName, CarSpeed

    Set CarSpeed = Nothing
    Set EngSpeed = Nothing
    set tool = nothing
    Set App = Nothing

  End If

  Sub APP_OnOpen(FullName)
    flag = 1 
  end Sub 

  Sub ShowSignal( name, signal)
    On Error Resume Next
    MsgBox "The current " & name & " is " & signal.Value, vbSystemModal
    If Err.Number = &H8000000A Then 
      MsgBox "The current " & name & " is not available.", vbSystemModal
    End If
  End Sub

  Function GetFullName( relpath)
    Dim fso, fullpath, msg
    On Error Resume Next
    Set fso = CreateObject("Scripting.FileSystemObject")
    fullpath = fso.GetFile( WScript.ScriptFullName).ParentFolder & relpath
    GetFullName = fso.GetFile( fullpath).Path
    Set fso = Nothing
    msg = "The object returned the following error: " & Chr(13) & Chr(13) & _
        "Code: 0x" & Hex(Err.Number) & Chr(13) & _
        "Source: " & Err.Source & Chr(13) & _
        "Description: " & Err.Description
    If err = 53 Then
      MsgBox msg, vbSystemModal + vbMsgBoxHelpButton, "Error", Err.HelpFile, Err.HelpContext
    End If
  End Function

  Sub OpenConfig( relpath, measurement)
    ' Open the specified config (if it isn't already)
    Dim FullName
    On Error Resume Next
    FullName = GetFullName( relpath)
    If measurement.Running Then
      measurement.Stop
    End If
    App.Open( FullName)
    If err = -2147467259 Then
      MsgBox "Script will interrupt!"
      WScript.Quit
    End If
  End Sub

  Function ReadCountry()
    Dim string
    Do While Not CountryStream.AtEndOfStream
      string = CountryStream.ReadLine
        if string = "Country=49" then
          ReadCountry = 49
        elseif string = "Country=01" then
          ReadCountry = 1
        end if
    Loop
    CountryStream.Close
  End Function  


  Function ReadStrict()
    Dim string
    Do While Not StrictStream.AtEndOfStream
      string = StrictStream.ReadLine 
        if string = "Distribution=NoUS" then
          ReadStrict = 0
        elseif string = "Distribution=US" then
          ReadStrict = 1
        end if
    Loop
    StrictStream.Close
  End Function 

